import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.assertFalse;


public class Aufgabe1Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);


    @Test
    public void testEquals() throws Exception {
        Person hubert = Aufgabe1.createHubert();
        Person julia = Aufgabe1.createJulia();
        Person thomas = Aufgabe1.createThomas();

        Person hubert2 = Aufgabe1.createHubert();
        Person julia2 = Aufgabe1.createJulia();
        Person thomas2 = Aufgabe1.createThomas();

        assertTrue(hubert.equals(hubert));
        assertTrue(hubert.equals(hubert2));

        assertFalse(hubert.equals(julia));
        assertFalse(hubert.equals(thomas));

        
        assertTrue(julia.equals(julia));
        assertTrue(julia.equals(julia2));

        assertFalse(julia.equals(hubert));
        assertFalse(julia.equals(thomas));


        assertTrue(thomas.equals(thomas));
        assertTrue(thomas.equals(thomas2));

        assertFalse(thomas.equals(hubert));
        assertFalse(thomas.equals(julia));
        

        assertTrue(hubert.hashCode() == hubert.hashCode());
        assertTrue(hubert.hashCode() == hubert2.hashCode());
        assertTrue(julia.hashCode() == julia.hashCode());
        assertTrue(julia.hashCode() == julia2.hashCode());
        assertTrue(thomas.hashCode() == thomas.hashCode());
        assertTrue(thomas.hashCode() == thomas2.hashCode());        
    }

    String example = "# Hubert Maier, maennlich, 88 Jahre, Svnr: 1234\n" +
            " # Julia Maier, weiblich, 54 Jahre, Svnr: 1111\n" +
            "  # Thomas Maier, maennlich, 22 Jahre, Svnr: 2222\n" +
            "  # Gernot Maier, maennlich, 24 Jahre, Svnr: 3333\n" +
            " # Gernot Mueller, maennlich, 40 Jahre, Svnr: 1115\n" +
            "  # Roman Mueller, maennlich, 12 Jahre, Svnr: 1116\n" +
            "  # Sophie Mueller, weiblich, 14 Jahre, Svnr: 1117";

    @Test
    public void testToString() throws Exception {
        Person hubert = Aufgabe1.createHubert();

        assertTrue(hubert.toString().equals(example));
    }

    @Test
    public void testNeuesKind() throws Exception {
        Person hubert = Aufgabe1.createHubert();
        Person julia = Aufgabe1.createJulia();
        Person thomas = Aufgabe1.createThomas();

        Person hubert2 = Aufgabe1.createHubert();
        Person julia2 = Aufgabe1.createJulia();
        Person thomas2 = Aufgabe1.createThomas();

        // should not modify hubert
        hubert.neuesKind(julia);
        assertTrue(hubert.toString().equals(example));
        hubert.neuesKind(julia2);
        assertTrue(hubert.toString().equals(example));
        assertTrue(hubert.equals(hubert2));

        // should modify hubert
        hubert.neuesKind(thomas);
        assertFalse(hubert.toString().equals(example));
        assertTrue(hubert.equals(hubert2));
    }
}