import org.junit.Rule;
import org.junit.Test;

import java.lang.reflect.Array;
import java.lang.reflect.Method;

import org.junit.rules.ExpectedException;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.*;

public class Aufgabe5Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Rule
    public ExpectedException exception = ExpectedException.none();

    @Test
    public void testHose() throws Exception {
        Kleidungsstueck ks = Aufgabe5.kaufeHose("unisex", "44");
        assertEquals(ks.toString(), "Hose: Weite Jogginghose, Blau, Hervis, PUM4-123, unisex, 44");
        assertEquals(ks.articleNr(), "PUM4-123");
    }

    @Test
    public void testKleiderschrankLeer() {
        Kleiderschrank ks = Aufgabe5.erstelleKleiderschrank("Voll", "Hubert", 0);
        Kleidungsstueck hose = Aufgabe5.kaufeHose("unisex", "44");
        exception.expect(IndexOutOfBoundsException.class);
        ks.add(hose);
    }

    @Test
    public void testKleiderschrank() {
        Kleiderschrank ks = Aufgabe5.erstelleKleiderschrank("Platz", "Sandra", 1);
        Kleidungsstueck hose = Aufgabe5.kaufeHose("weiblich", "32");
        assertEquals(ks.toString(),
                "Kleiderschrank Platz von Sandra, Gesammtes Fassungsvermögen: 1, Anzahl der noch aufnehmbaren Kleidungsstuecke: 1, Inhalt:");
        ks.add(hose);
        assertEquals(ks.toString(),
                "Kleiderschrank Platz von Sandra, Gesammtes Fassungsvermögen: 1, Anzahl der noch aufnehmbaren Kleidungsstuecke: 0, Inhalt:\n" +
                "Hose: Weite Jogginghose, Blau, Hervis, PUM4-123, weiblich, 32");
        exception.expect(IndexOutOfBoundsException.class);
        ks.add(hose);
    }

}